using System;
using System.Windows.Controls;
using System.Windows.Input;

namespace DynamicGridViewDemo
{
    public class CommandBehaviorBase<T> 
    {
        private ICommand command;
        private object commandParameter;

        public ICommand Command
        {
            get { return command; }
            set
            {
                this.command = value;
            }
        }

        public object CommandParameter
        {
            get { return this.commandParameter; }
            set
            {
                if (this.commandParameter != value)
                {
                    this.commandParameter = value;
                }
            }
        }

        protected virtual void ExecuteCommand()
        {
            if (this.Command != null)
            {
                this.Command.Execute(this.CommandParameter);
            }
        }
    }
}