﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Data;
using System.Windows.Controls.Primitives;
using System.Windows.Markup;
using DevExpress.AgMenu;
using System.Text;
using System.Collections.ObjectModel;

namespace DynamicGridViewDemo
{
    public partial class DynamicGridView : UserControl
    {
        public DynamicGridView()
        {
            InitializeComponent();
        }

        public DynamicGridView(DynamicGridViewModel viewModel)
            : this()
        {
            this.ViewModel = viewModel;
            this.ViewModel.View = this;
        }

        public DynamicGridViewModel ViewModel
        {
            get
            {
                return this.DataContext as DynamicGridViewModel;
            }
            set
            {
                this.DataContext = value;

                ((ObservableCommand)this.Resources["MouseLeftButtonUpCommand"]).Value = value.MouseLeftButtonUpCommand;
            }
        }

        //public void LoadColumns()
        //{
        //    var stream = GetType().Assembly.GetManifestResourceStream("DynamicGridViewDemo.CarriedNO1.xaml");
        //    var xaml = new System.IO.StreamReader(stream).ReadToEnd();
        //    var datagrid = XamlReader.Load(xaml) as DataGrid;

        //    //this.FlightPlanning.Columns.Clear();

        //    //ItemsSource="{Binding FlightList, Mode=OneWay}"

        //}

//        public void AddNewColumn(string path)
//        {
//            DataGridTemplateColumn column = new DataGridTemplateColumn() { Header = path, SortMemberPath=path };

//            StringBuilder sb = new StringBuilder();
//            sb.Append(@"                
//                <DataTemplate                  
//                    xmlns='http://schemas.microsoft.com/client/2007'                   
//                    xmlns:x='http://schemas.microsoft.com/winfx/2006/xaml'                  
//                    >                    
//                   <TextBlock Tag='");
//            sb.Append(path);
//            sb.Append(@"' Text='{Binding ");
//            sb.Append(path);
//            sb.Append(@"}' ");
//            sb.Append(@"/>
//                </DataTemplate>");

//            column.CellTemplate = XamlReader.Load(sb.ToString()) as DataTemplate;
            
//            FlightPlanning.Columns.Add(column);
//        }

        public void PopMenuByColumnID(MouseButtonEventArgs e)
        {
            TextBlock source = e.OriginalSource as TextBlock;
            if (source == null) return;

            //no tag means no popup event
            if (source.Tag == null) return;

            PopMenuByColumnID(source.Tag);
            PopMenues(e);
        }

        void PopMenuByColumnID(object tag)
        {
            foreach (var item in menu.Items)
            {
                AgMenuItem ai = item as AgMenuItem;
                if (tag.ToString().Equals(ai.Tag.ToString()))
                    ai.Visibility = Visibility.Visible;
                else
                    ai.Visibility = Visibility.Collapsed;
            }
        }

        public void LoadMenu()
        {
            LayoutRoot.Children.Remove(menu);

            var stream = GetType().Assembly.GetManifestResourceStream("DynamicGridViewDemo.PopupMenu.xaml");
            var xaml = new System.IO.StreamReader(stream).ReadToEnd();
            menu = XamlReader.Load(xaml) as AgPopupMenu;

            SetHandler(menu.Items);
            LayoutRoot.Children.Add(menu);
        }

        public void PopMenues(MouseButtonEventArgs e)
        {
            FrameworkElement myroot = LayoutRoot;
            while (myroot != null)
            {
                myroot = (FrameworkElement)myroot.Parent;
            }
            Point p = e.GetPosition(myroot);
            menu.Popup(LayoutRoot, p);
        }

        public void SetHandler(ItemCollection itemCollection)
        {
            foreach (AgMenuItem item in itemCollection)
            {
                string header = item.Header.ToString();
                //switch (header)
                //{
                //    case "Activate Flight":
                //        item.Click += ViewModel.OnDUI2Click;
                //        break;
                //    case "Overfly":
                //        item.Click += ViewModel.OnOverflyClick;
                //        break;
                //    case "Placards":
                //        item.Click += ViewModel.OnPlacardsClick;
                //        break;
                //    case "Stn Runway Information":
                //        item.Click += ViewModel.OnStationRunwayClick;
                //        break;
                //    case "Stn Contact Information":
                //        item.Click += ViewModel.OnStationContactClick;
                //        break;
                //    case "Aircraft Information":
                //        item.Click += ViewModel.OnAircraftInformationClick;
                //        break;
                //    case "Captain's ETA":
                //        item.Click += ViewModel.OnCaptainETAClick;
                //        break;
                //    default:
                //        break;
                //}
            }
        }
    }
}