﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace DynamicGridViewDemo
{
    public class FormFieldTemplateSelector : UserControl
    {
        public DataTemplate FirstTemplate { get; set; }
        public DataTemplate SecondTemplate { get; set; }

        public static readonly DependencyProperty FieldTypeProperty =
            DependencyProperty.Register("FieldType", typeof(string),
            typeof(FormFieldTemplateSelector), new PropertyMetadata(string.Empty));

        public string FieldType
        {
            get { return (string)GetValue(FieldTypeProperty); }
            set { SetValue(FieldTypeProperty, value); }
        }

        public FormFieldTemplateSelector()
        {
            Loaded += new RoutedEventHandler(OnLoaded);
        }

        private void OnLoaded(object sender, RoutedEventArgs e)
        {
            string fieldType = FieldType;
            if (fieldType == "1")
            {
                Content = FirstTemplate.LoadContent() as UIElement;
            }
            else if (fieldType == "2")
            {
                Content = SecondTemplate.LoadContent() as UIElement;
            }
            else
            {
                Content = null;
            }
        }
    }
}